package com.example.sam4s;

import java.io.InputStream;

import com.example.sam4s.R;
import com.sam4s.printer.Sam4sBuilder;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;

public class cl_Image extends Activity implements OnClickListener{
	static final int SEND_TIMEOUT = 10 * 1000;
    static final int REQUEST_CODE = 12345;
    static final int IMAGE_WIDTH_MAX = 512;
    
    Bitmap selectImage = null;
    boolean exitActivity = false;
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.image);
    
        //check close port
        if(cl_Menu.mPrinter == null){
            finish();
            return ;
        }
        
        //Registration ClickListener
        Button button = (Button)findViewById(R.id.button_print);
        button.setOnClickListener(this);

        button = (Button)findViewById(R.id.button_select);
        button.setOnClickListener(this);
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if(keyCode == KeyEvent.KEYCODE_BACK){
            exitActivity = true;
        }
        
        return super.onKeyDown(keyCode, event);
    }
    
    @Override
    public void onClick(View v) {
        switch(v.getId()){
        case    R.id.button_print:
            printImage();
            break;
        case    R.id.button_select:
            selectImage();
            break;
        default:
            break;
        }
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (resultCode == RESULT_OK && requestCode == REQUEST_CODE) {
            ImageView view = (ImageView)findViewById(R.id.imageView);
            try {
                InputStream in = getContentResolver().openInputStream(data.getData());
                selectImage = BitmapFactory.decodeStream(in);

                if(view.getWidth() < selectImage.getWidth()
                            || view.getHeight() < selectImage.getHeight()){
                    view.setScaleType(ScaleType.FIT_CENTER);
                }else{
                    view.setScaleType(ScaleType.CENTER);
                }
                view.setImageBitmap(selectImage);

                in.close();
            } catch (Exception e) {
                view.setImageBitmap(null);
            }
        }
    }
    
    private void selectImage() {
        Intent intent = new Intent();
        intent.setType("image/*");
        intent.setAction(Intent.ACTION_GET_CONTENT);
        startActivityForResult(intent, REQUEST_CODE);
    }
    
    private void printImage() {
        if(selectImage == null){
        	cl_Main.showMsg("No Image", this);
            return ;
        }
        
        Sam4sBuilder builder = null;
        
        try{
            //create builder
            Intent intent = getIntent();
            //Builder
            builder = new Sam4sBuilder(
                    intent.getStringExtra("printername"), intent.getIntExtra("language", 0));

            //add command
            //addImage            
            builder.addImage(selectImage, selectImage.getWidth(), selectImage.getHeight());

            //send builder data
            try{     
            	cl_Menu.mPrinter.sendData(builder);
       
            }catch(Exception e){
            	cl_Main.showMsg(e.getLocalizedMessage(), this);
            }
        }catch(Exception e){
        	cl_Main.showMsg(e.getLocalizedMessage(), this);
        }
        
        //remove builder
        if(builder != null){
            try{
                builder.clearCommandBuffer();
                builder = null;
            }catch(Exception e){
                builder = null;
            }
        }
    }
}
